#!/bin/bash

HOST=$PWD
INS_HOME_PATH="${HOST}/application"

export CC=clang
export CXX=clang++
export FC=flang
export MPICC=mpicc
export MPICXX=mpicxx
export MPIFC=mpifort

export HDF5=${HOST}/HDF5
export NETCDF=${HOST}/NETCDF
export PNETCDF=${HOST}/PNETCDF
export ZLIB=${HOST}/ZLIB

cd $INS_HOME_PATH/WRF-4.2
export LD_LIBRARY_PATH=${ZLIB}/lib:$LD_LIBRARY_PATH
export PATH=${NETCDF}/bin:$PATH
export LD_LIBRARY_PATH=${NETCDF}/lib:$LD_LIBRARY_PATH
export PATH=${HDF5}/bin:$PATH
export LD_LIBRARY_PATH=${HDF5}/lib:$LD_LIBRARY_PATH

wrf_install(){
    cp ${HOST}/configure.defaults.patch ./
    patch -p1 < ./configure.defaults.patch
    echo 4 | ./configure
    sed -i 's/derf/erf/g' ./phys/module_mp_SBM_polar_radar.F
    sed -i -e 's/gcc/clang/g' \
      -e 's/gfortran/flang/g' \
      -e 's/mpicc/mpicc -DMPI2_SUPPORT/g' \
      -e 's/ -ftree-vectorize//g' \
      -e 's/length-none/length-0/g' \
      -e 's/-frecord-marker\=4/ /g' \
      -e 's/\-w \-O3 \-c/-mcpu=native \-w \-O3 \-c/g' \
      -e 's/\# \-g $(FCNOOPT) .*/\-g/g' \
      -e 's/$(FCBASEOPTS_NO_G)/-mcpu=native $(OMP) $(FCBASEOPTS_NO_G)/g' configure.wrf
    ./compile -j $(nproc) em_real | tee compile.log
}

wrf_install