# README for Kunpeng Porting Advisor

## 一、关于鲲鹏代码迁移工具

**鲲鹏代码迁移工具是一个用于帮助用户从x86平台向鲲鹏平台进行源码工程和软件安装包迁移适配项扫描的本地工具。**

**工具通过扫描源码工程中的C/C++/Fortran/Python/Java/Scala/Go/ASM文件和makefile构建文件，检出需迁移的代码，生成一份迁移检查报告，供用户进行迁移参考。**

**工具不会修改、存储和上传任何源代码，仅运行在用户本地环境。** 

## 二、使用说明

**下载工具包：Porting-adviosr_x.x.x_linux-xxx.tar.gz，上传到目标操作系统上，执行以下操作：**
```sh
# 示例
./porting-advisor -S /usr/sample_code_dir/ -C gcc4.8.5 --cmd "make" --tos centos7.6

# Usage
./porting-advisor -h
usage: porting-advisor
        [-h] [-P PACKAGES] [-S SOURCE --cmd CMD] --tos TARGET_OS
        [-C COMPILER] [--fc-ver] [--go] [--interpreted]
        [-T TOOLS] [--tk TARGET_KERNEL] [-D {DEBUG,INFO,WARN,ERR}]
        [-O OUTPUT] [-V] [--loc c_line, asm_line] [--ee True]
        [--keep-going True or False]

Generate a Kunpeng aarch64 migrating report.

optional arguments:
  -h, --help            show this help message and exit
  -S SOURCE, --source SOURCE
                        directories of source folder
  -P PACKAGES, --packages PACKAGES
                        binary package to be scanned.
  -V, --version         show program's version number and exit
  -C {bisheng compiler2.1.0,bisheng compiler2.3.0,bisheng compiler2.4.0,bisheng compiler2.5.0,bisheng compiler2.5.0.1,bisheng compiler3.0.0,bisheng compiler3.1.0,bisheng compiler3.2.0,gcc4.8.5,gcc4.9.3,gcc5.1.0,gcc5.2.0,gcc5.3.0,gcc5.4.0,gcc5.5.0,gcc6.1.0,gcc6.2.0,gcc6.3.0,gcc6.4.0,gcc6.5.0,
      gcc7.1.0,gcc7.2.0, gcc7.3.0,gcc7.4.0,gcc8.1.0,gcc8.2.0,gcc8.3.0,gcc9.1.0,gcc9.2.0,gcc9.3.0,gcc10.1.0,gcc10.2.0,gcc10.3.0,gcc10.3.1},
      --compiler {bisheng compiler2.1.0,bisheng compiler2.3.0,bisheng compiler2.4.0,bisheng compiler2.5.0,bisheng compiler2.5.0.1,bisheng compiler3.0.0,bisheng compiler3.1.0,bisheng compiler3.2.0,gcc4.8.5,gcc4.9.3,gcc5.1.0,gcc5.2.0,gcc5.3.0,gcc5.4.0,gcc5.5.0,gcc6.1.0,gcc6.2.0,gcc6.3.0,gcc6.4.0,
      gcc6.5.0,gcc7.1.0,gcc7.2.0,gcc7.3.0,gcc7.4.0,gcc8.1.0,gcc8.2.0,gcc8.3.0,gcc9.1.0,gcc9.2.0,gcc9.3.0,gcc10.1.0,gcc10.2.0,gcc10.3.0,gcc10.3.1}
                        specify compiler type.
  --fc-ver {flang2.1.0, flang2.3.0, flang2.4.0, flang2.5.0, flang2.5.0.1, flang3.0.0, flang3.1.0, flang3.2.0, gfortran7, gfortran8, gfortran9}
                        specify compiler type.
  -O OUTPUT, --output OUTPUT
                        specify output report type. Only csv is supported.
  -D {DEBUG,INFO,WARN,ERR}, --debug {DEBUG,INFO,WARN,ERR}
                        specify log level. default is INFO. choices from: DEBUG, INFO, WARN, ERR
  -T {make,cmake,automake,go}, --tools {make,cmake,automake,go}
                        specify construction. default is make.
  --cmd CMD             specify instruction command line.
  --tos {bclinux7.6,bclinux7.7,centos7.4,centos7.5,centos7.6,centos7.7,centos8.0,centos8.1,centos8.2,debian10,
         deepinv15.2,euleros2.8,isoft5.1,kylinv10sp1,kylinv10sp2,kylinv10sp3,linxos6.0.90,neokylinv7u5,neokylinv7u6,openeuler20.03,
         openeuler22.03,openeuler22.03sp1,openeuler20.03sp1,openeuler20.03sp2,openeuler20.03sp3,susesles15.1,ubuntu18.04.x,ubuntu20.04.x,uos20sp1,
         uoseuler20,uos20-1020e,uos20-1050e,kylinsecos3.4}
                        specify target os system and os version.
  --loc LOC             Source code workload evaluation standard. For example "--loc c_line,asm_line".
  --ee {True}           Report show workload.
  --tk TARGET_KERNEL    specify target kernel version.
  --keep-going {True,False}
                        The values of Continue scanning with keyword arm/arm64/aarch64.
  --go                  Scan Go files.
  --interpreted         Scan the interpretative language files. 
```

## 三、工具原理

 **鲲鹏代码迁移工具支持源码迁移和软件迁移评估两大功能。**
 **源码迁移功能参考特定编译构建工具(GCC、make、cmake、go)对C/C++/Fortran/Python/Java/Scala/Go/ASM等源码工程进行扫描，并识别源码中涉及到x86_64向aarch64平台迁移相关的编译器宏、编译选项、编译器attribute、嵌入式和纯汇编代码等关键字信息。并对这些信息给出具体的csv格式报告, 供用户迁移参考。**
 **软件迁移评估是鲲鹏代码迁移工具的一项重要功能，它可以检查x86平台软件安装包或已安装软件中使用的动态链接库、静态链接库和可执行文件，并将检查出的文件与工具内置的依赖文件列表进行比较匹配，从而为用户提供迁移建议。**

## 四、常见问题说明

> **1.如何输入多个扫描路径？**
```sh
# 方式1
./porting-advisor -S /usr/sample_code_dir1/,/usr/sample_code_dir2/ -C gcc4.8.5 --cmd "make" --tos centos7.6
# 方式2
./porting-advisor -S "/usr/sample_code_dir1/,  /usr/sample_code_dir2/" -C gcc4.8.5 --cmd "make" --tos centos7.6
```

> **2.如何查看扫描结果？**
```sh
# 扫描结束后，根据终端回显路径获取csv报告
For the detailed information, please check /path/cmd/report/sourcecode/20210824120133/porting-advisor.csv
```

## 五、版权声明

***版权所有 (C) 华为技术有限公司 2023 保留一切权利***

## 六、隐私声明

**鲲鹏代码迁移工具仅在用户本地对源码工程和软件包进行扫描和报告生成，不会以任何形式修改、存储、上传用户的源代码内容**
