# README for Kunpeng Porting Advisor

## 1. About Kunpeng Porting Advisor

**Kunpeng Porting Advisor is a local tool used to help users scan adaptation items for porting source code projects and software Package from the x86 platform to the Kunpeng platform. **

** The tool scans the C/C++/Fortran/Python/Java/Scala/Go/ASM file and makefile to build file in the source code project, detects the code to be ported, and generates a porting check report for users. **

** The tool does not modify, store, or upload any source code, and runs only in the local environment. ** 

## 2. Usage Instruction

** Download the tool package 'Porting-adviosr_x.x.x_linux-xxx.tar.gz', upload it to the target OS, and perform the following operations: **
```sh
# Example
./porting-advisor -S /usr/sample_code_dir/ -C gcc4.8.5 --cmd "make" --tos centos7.6

# Usage
./porting-advisor -h
usage: porting-advisor
        [-h] [-P PACKAGES] [-S SOURCE --cmd CMD] --tos TARGET_OS
        [-C COMPILER] [--fc-ver] [--go] [--interpreted]
        [-T TOOLS] [--tk TARGET_KERNEL] [-D {DEBUG,INFO,WARN,ERR}]
        [-O OUTPUT] [-V] [--loc c_line, asm_line] [--ee True]
        [--keep-going True or False]

Generate a Kunpeng aarch64 migrating report.

optional arguments:
  -h, --help            show this help message and exit
  -S SOURCE, --source SOURCE
                        directories of source folder
  -P PACKAGES, --packages PACKAGES
                        binary package to be scanned.
  -V, --version         show program's version number and exit
  -C {bisheng compiler2.1.0,bisheng compiler2.3.0,bisheng compiler2.4.0,bisheng compiler2.5.0,bisheng compiler2.5.0.1,bisheng compiler3.0.0,bisheng compiler3.1.0,bisheng compiler3.2.0,gcc4.8.5,gcc4.9.3,gcc5.1.0,gcc5.2.0,gcc5.3.0,gcc5.4.0,gcc5.5.0,gcc6.1.0,gcc6.2.0,gcc6.3.0,gcc6.4.0,gcc6.5.0,
      gcc7.1.0,gcc7.2.0, gcc7.3.0,gcc7.4.0,gcc8.1.0,gcc8.2.0,gcc8.3.0,gcc9.1.0,gcc9.2.0,gcc9.3.0,gcc10.1.0,gcc10.2.0,gcc10.3.0,gcc10.3.1},
      --compiler {bisheng compiler2.1.0,bisheng compiler2.3.0,bisheng compiler2.4.0,bisheng compiler2.5.0,bisheng compiler2.5.0.1,bisheng compiler3.0.0,bisheng compiler3.1.0,bisheng compiler3.2.0,gcc4.8.5,gcc4.9.3,gcc5.1.0,gcc5.2.0,gcc5.3.0,gcc5.4.0,gcc5.5.0,gcc6.1.0,gcc6.2.0,gcc6.3.0,gcc6.4.0,
      gcc6.5.0,gcc7.1.0,gcc7.2.0,gcc7.3.0,gcc7.4.0,gcc8.1.0,gcc8.2.0,gcc8.3.0,gcc9.1.0,gcc9.2.0,gcc9.3.0,gcc10.1.0,gcc10.2.0,gcc10.3.0,gcc10.3.1}
                        specify compiler type.
  --fc-ver {flang2.1.0, flang2.3.0, flang2.4.0, flang2.5.0, flang2.5.0.1, flang3.0.0, flang3.1.0, flang3.1.0, gfortran7, gfortran8, gfortran9}
                        specify compiler type.
  -O OUTPUT, --output OUTPUT
                        specify output report type. Only csv is supported.
  -D {DEBUG,INFO,WARN,ERR}, --debug {DEBUG,INFO,WARN,ERR}
                        specify log level. default is INFO. choices from: DEBUG, INFO, WARN, ERR
  -T {make,cmake,automake,go}, --tools {make,cmake,automake,go}
                        specify construction. default is make.
  --cmd CMD             specify instruction command line.
  --tos {bclinux7.6,bclinux7.7,centos7.4,centos7.5,centos7.6,centos7.7,centos8.0,centos8.1,centos8.2,debian10,
         deepinv15.2,euleros2.8,isoft5.1,kylinv10sp1,kylinv10sp2,kylinv10sp3,linxos6.0.90,neokylinv7u5,neokylinv7u6,openeuler20.03,
         openeuler22.03,openeuler22.03sp1,openeuler20.03sp1,openeuler20.03sp2,openeuler20.03sp3.susesles15.1,ubuntu18.04.x,ubuntu20.04.x,uos20sp1,
         uoseuler20,uos20-1020e,uos20-1050e,kylinsecos3.4}
                        specify target os system and os version.
  --loc LOC             Source code workload evaluation standard. For example "--loc c_line,asm_line".
  --ee {True}           Report show workload.
  --tk TARGET_KERNEL    specify target kernel version.
  --keep-going {True,False}
                        The values of Continue scanning with keyword arm/arm64/aarch64.
  --go                  Scan Go files.
  --interpreted         Scan the interpretative language files.
```

## 3. Principles of the Tool

 ** The Kunpeng Porting Advisor supports source code porting and software porting assessment.  **
 ** The source code porting function scans the C/C++/Fortran/Python/Java/Scala/Go/ASM source code project by referring to specific compilation and build tools (GCC, make, cmake, and go). It can identify keywords such as compiler macros, compilation options, compiler attributes, embedded code, and pure assembly code related to porting from x86_64 to the aarch64 platform. A CSV report is then provided for users to perform porting. **
 ** The software porting assessment is an important function of the Kunpeng Porting Advisor. It can check the dynamic link libraries, static link libraries, and executable files used in the x86 platform software installation package or installed software, and compare the checked files with the built-in dependency file list of the tool. This provides users with porting suggestions. **

## 4. FAQs

> ** (1). How do I enter multiple scan paths? **
```sh
# Method 1
./porting-advisor -S /usr/sample_code_dir1/,/usr/sample_code_dir2/ -C gcc4.8.5 --cmd "make" --tos centos7.6
# Method 2
./porting-advisor -S "/usr/sample_code_dir1/,  /usr/sample_code_dir2/" -C gcc4.8.5 --cmd "make" --tos centos7.6
```

> ** (2) How do I view the scanning result? **
```sh
# After the scanning is complete, obtain the CSV report from the path displayed on the terminal.
For the detailed information, please check /path/cmd/report/sourcecode/20210824120133/porting-advisor.csv
```

## 5. Copyright

Copyright (C) Huawei Technologies Co., Ltd. 2023. All rights reserved.

## 6. Privacy Statement

** Kunpeng Porting Advisor scans source code projects and software packages, and generates reports only on the local environment, and does not modify, store, or upload the source code of users. **